---
title: AudioWorkletGlobalScope
slug: Web/API/AudioWorkletGlobalScope
tags:
  - API
  - Audio
  - AudioWorklet
  - AudioWorkletGlobalScope
  - Background
  - Interface
  - Reference
  - Web Audio API
  - Worklet
  - global
  - scope
  - sound
---
<p>{{APIRef("Web Audio API")}}</p>

<p><span class="seoSummary">The <strong><code>AudioWorkletGlobalScope</code></strong> interface of the <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a> represents a global execution context for user-supplied code, which defines custom {{domxref("AudioWorkletProcessor")}}-derived classes.</span> Each {{domxref("BaseAudioContext")}} has a single {{domxref("AudioWorklet")}} available under the {{domxref("BaseAudioContext.audioWorklet", "audioWorklet")}} property, which runs its code in a single <code>AudioWorkletGlobalScope</code>.</p>

<p>As the global execution context is shared across the current <code>BaseAudioContext</code>, it's possible to define any other variables and perform any actions allowed in worklets — apart from defining <code>AudioWorkletProcessor</code>-derived classes.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("AudioWorkletGlobalScope.currentFrame", "currentFrame")}} {{readonlyinline}}</dt>
 <dd>Returns an integer that represents the ever-increasing current sample-frame of the audio block being processed. It is incremented by 128 (the size of a render quantum) after the processing of each audio block.</dd>
 <dt>{{domxref("AudioWorkletGlobalScope.currentTime", "currentTime")}} {{readonlyinline}}</dt>
 <dd>Returns a double that represents the ever-increasing context time of the audio block being processed. It is equal to the {{domxref("BaseAudioContext.currentTime", "currentTime")}} property of the {{domxref("BaseAudioContext")}} the worklet belongs to.</dd>
 <dt>{{domxref("AudioWorkletGlobalScope.sampleRate", "sampleRate")}} {{readonlyinline}}</dt>
 <dd>Returns a float that represents the sample rate of the associated {{domxref("BaseAudioContext")}}.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("AudioWorkletGlobalScope.registerProcessor", "registerProcessor()")}}</dt>
 <dd>Registers a class derived from the {{domxref('AudioWorkletProcessor')}} interface. The class can then be used by creating an {{domxref("AudioWorkletNode")}}, providing its registered name.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In this example we output all global properties into the console in the constructor of a custom {{domxref("AudioWorkletProcessor")}}.</p>

<p>First we need to define the processor, and register it. Note that this should be done in a separate file.</p>

<pre class="brush: js notranslate">// test-processor.js
class TestProcessor extends AudioWorkletProcessor {
  constructor () {
    super()
    // current sample-frame and time at the moment of instantiation
    // to see values change, you can put these two lines in process method
    console.log(currentFrame)
    console.log(currentTime)
  }
  // the process method is required - output silence,
  // which the outputs are already filled with
  process (inputs, outputs, parameters) {
    return true
  }
}

// the sample rate is not going to change ever,
// because it's a read-only property of a BaseAudioContext
// and is set only during its instantiation
console.log(sampleRate)

// you can declare any variables and use them in your processors
// for example it may be an ArrayBuffer with a wavetable
const usefulVariable = 42
console.log(usefulVariable)

registerProcessor('test-processor', TestProcessor)
</pre>

<p>Next, in our main scripts file we'll load the processor, create an instance of <code>AudioWorkletNode</code> — passing the name of the processor to it — and connect the node to an audio graph. We should see the output of <code>console.log</code> calls in the console:</p>

<pre class="brush: js notranslate">const audioContext = new AudioContext()
await audioContext.audioWorklet.addModule('test-processor.js')
const testNode = new AudioWorkletNode(audioContext, 'test-processor')
testNode.connect(audioContext.destination)
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#audioworkletglobalscope', 'AudioWorkletGlobalScope')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioWorkletGlobalScope")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
